package com.fc2.blog68.symfoware.ikensyo;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.WindowEvent;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import jp.nichicom.ac.component.mainmenu.ACMainMenuButton;
import jp.nichicom.ac.core.ACFrame;
import jp.nichicom.vr.layout.VRLayout;
import jp.or.med.orca.ikensho.affair.IkenshoDialog;

public class SubMenu extends IkenshoDialog {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private VRLayout menusLayout = new VRLayout();
	private JPanel contentPane;
	private ACMainMenuButton close;

	public static final int SUB_CLOSED = 0;
	public static final int SUB_COLLABORATION = 1;
	public static final int SUB_LIST_PRINT = 2;

	private int pushedButton = SUB_CLOSED;

	public SubMenu(Frame owner, String title, boolean modal) {
		super(ACFrame.getInstance(), title, modal);

		try {
			setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			jbInit();
			pack();
			initSubMenu();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public SubMenu() {
		this(new Frame(), "title", true);
	}

	private void jbInit() throws Exception {
		contentPane = (JPanel) getContentPane();
		this.getContentPane().setBackground(Color.white);
		contentPane.setLayout(menusLayout);
		menusLayout.setFitHLast(true);

		//
		close = new ACMainMenuButton("(E)");
		close.setToolTipText("ʂ܂B");
		close.setMnemonic('E');
		close.setIcon(new ImageIcon(getClass().getClassLoader().getResource(
				"jp/or/med/orca/ikensho/images/menu/menuicon_17.png")));
		close.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				pushedButton = SUB_CLOSED;
				closeWindow();
			}
		});
	}

	private void initSubMenu() {

		//Tuj[ݒ
		setMenuExtentin();
		setSize(new Dimension(600, 50 + 72 * contentPane.getComponentCount()));

		//EBhE𒆉ɔzu
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension frameSize = this.getSize();
		if (frameSize.height > screenSize.height) {
			frameSize.height = screenSize.height;
		}
		if (frameSize.width > screenSize.width) {
			frameSize.width = screenSize.width;
		}
		this.setLocation((screenSize.width - frameSize.width) / 2,
				(screenSize.height - frameSize.height) / 2);
	}

	private void setMenuExtentin() {
		setTitle("g@\");

		ACMainMenuButton collaboration = new ACMainMenuButton();
		ACMainMenuButton listPrint = new ACMainMenuButton();

		//f[^Ag
		collaboration = new ACMainMenuButton("Symfowref[^荞(D)");
		collaboration.setToolTipText("Symfowreɓo^Ăf[^荞݂܂B");
		collaboration.setMnemonic('D');
		collaboration.setIcon(new ImageIcon(getClass().getClassLoader()
				.getResource("com/fc2/blog68/symfoware/image/02.png")));
		collaboration.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				pushedButton = SUB_COLLABORATION;
				closeWindow();
			}
		});

		//ꗗ
		listPrint = new ACMainMenuButton("ꗗ(L)");
		listPrint.setToolTipText("Symfowareɓo^Ăf[^̈ꗗ܂B");
		listPrint.setMnemonic('L');
		listPrint.setIcon(new ImageIcon(getClass().getClassLoader()
				.getResource("com/fc2/blog68/symfoware/image/03.png")));
		listPrint.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				pushedButton = SUB_LIST_PRINT;
				closeWindow();
			}
		});

		//j[ɒǉ
		contentPane.add(collaboration, VRLayout.NORTH);
		contentPane.add(listPrint, VRLayout.NORTH);
		contentPane.add(close, VRLayout.NORTH);
	}

	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			closeWindow();
		}
	}

	protected void closeWindow() {
		this.dispose();
	}

	public int getPushedButtion() {
		return pushedButton;
	}

}
