package com.fc2.blog68.symfoware.ikensyo;

import java.awt.*;
import java.awt.event.*;
import java.awt.im.InputSubset;
import java.text.*;
import java.util.*;

import javax.swing.SwingConstants;

import com.fc2.blog68.symfoware.lib.SymfowareDBManager;

import jp.nichicom.ac.*;
import jp.nichicom.ac.component.*;
import jp.nichicom.ac.component.table.*;
import jp.nichicom.ac.container.*;
import jp.nichicom.ac.core.*;
import jp.nichicom.ac.util.*;
import jp.nichicom.ac.util.adapter.*;
import jp.nichicom.ac.util.splash.*;
import jp.nichicom.vr.bind.*;
import jp.nichicom.vr.component.table.VRTableColumnModel;
import jp.nichicom.vr.layout.VRLayout;
import jp.nichicom.vr.text.VRCharType;
import jp.nichicom.vr.text.parsers.VRDateParser;
import jp.nichicom.vr.util.*;
import jp.or.med.orca.ikensho.IkenshoConstants;
import jp.or.med.orca.ikensho.affair.IkenshoAffairContainer;
import jp.or.med.orca.ikensho.affair.IkenshoFrameEventProcesser;
import jp.or.med.orca.ikensho.component.table.IkenshoCheckBoxTableCellEditor;
import jp.or.med.orca.ikensho.component.table.IkenshoCheckBoxTableCellRenderer;
import jp.or.med.orca.ikensho.lib.IkenshoCommon;
import jp.or.med.orca.ikensho.sql.IkenshoFirebirdDBManager;

public class SymfowareCollaboration  extends IkenshoAffairContainer implements ACAffairable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ACAffairButtonBar buttons = new ACAffairButtonBar();
    private ACTable patients = new ACTable();
    private ACGroupBox accessSettings = new ACGroupBox();
    private ACLabelContainer hostNames = new ACLabelContainer();
    private ACTextField hostName = new ACTextField();
    private ACTextField userName = new ACTextField();
    private ACLabelContainer userNames = new ACLabelContainer();
    private ACTextField port = new ACTextField();
    private ACLabelContainer ports = new ACLabelContainer();
    private ACTextField password = new ACTextField();
    private ACLabelContainer passwords = new ACLabelContainer();
    private ACAffairButton receiptAccess = new ACAffairButton();
    private IkenshoCheckBoxTableCellEditor deleteCheckEditor = new IkenshoCheckBoxTableCellEditor();
    private VRArrayList importPatients = new VRArrayList();
    private ACTableModelAdapter patientsModelAdapter;
    private ACAffairButton patinetImport = new ACAffairButton();
    private VRList patientsData;
    private ACGroupBox filterSettings = new ACGroupBox();
    private ACButton nextPage = new ACButton();
    private ACButton previewPage = new ACButton();
    private ACTextField patientID = new ACTextField();
    private ACLabel foundCountValue = new ACLabel();
    private ACLabel foundCountUnit = new ACLabel();
    private ACLabel viewIndexBegin = new ACLabel();
    private ACLabel viewIndexBeginUnit = new ACLabel();
    private ACLabel viewIndexEnd = new ACLabel();
    private ACLabel viewIndexEndUnit = new ACLabel();
    private ACComboBox checkEditMethod = new ACComboBox();
    private ACButton checkEdit= new ACButton();
    private ACLabelContainer checkEditMethodContainer = new ACLabelContainer();
    private int foundCount=0; 
    private int pageBegin=0;
    
    /**
     * 1y[W̕\łB
     */
    private final int PAGE_COUNT = 100;

    public void initAffair(ACAffairInfo affair) {
        setStatusText("Symfowaref[^荞");
        
        String ip = "127.0.0.1";
        String port = "2002";
        String user = "Administrator";
        String pass = "";
        
        try{
            //ߋ̒ʐMݒǂݍ
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/IP")){
                ip = ACFrame.getInstance().getProperty("SymfowareAccess/IP");
            }
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/Port")){
                port = ACFrame.getInstance().getProperty("SymfowareAccess/Port");
            }
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/UserName")){
                user = ACFrame.getInstance().getProperty("SymfowareAccess/UserName");
            }
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/Password")){
                pass = ACFrame.getInstance().getProperty("SymfowareAccess/Password");
            }
        }catch(Exception ex){
            
        }
        hostName.setText(ip);
        userName.setText(user);
        password.setText(pass);
        this.port.setText(port);
    }

    /**
     * RXgN^
     */
    public SymfowareCollaboration() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

        addFindTrigger(receiptAccess);
        addInsertTrigger(patinetImport);


        patients.setColumnModel(new VRTableColumnModel(new ACTableColumn[] {
                new ACTableColumn(8, 22, "@",
                        new IkenshoCheckBoxTableCellRenderer(),
                        deleteCheckEditor),
                new ACTableColumn(9, 32, "d", SwingConstants.CENTER),
                new ACTableColumn(1, 100, ""),
                new ACTableColumn(2, 120, "ӂ肪"),
                new ACTableColumn(3, 32, "", SwingConstants.CENTER,
                        IkenshoConstants.FORMAT_SEX),
                new ACTableColumn(4, 32, "N", SwingConstants.RIGHT,
                        IkenshoConstants.FORMAT_NOW_AGE),
                new ACTableColumn(4, 110, "N",
                        IkenshoConstants.FORMAT_ERA_YMD),
                new ACTableColumn(5, 63, "X֔ԍ"),
                new ACTableColumn(6, 280, "Z"),
                new ACTableColumn(7, 120, "AiTELj"), }));

        patientsModelAdapter = new ACTableModelAdapter(importPatients,
                new String[] { "CHART_NO", "PATIENT_NM", "PATIENT_KN", "SEX", "BIRTHDAY",
                        "POST_CD", "ADDRESS", "TEL", "IMPORT_FLAG",
                        "BATTING_FLAG" });

        patients.setModel(patientsModelAdapter);

    }

    /**
     * ̊҂݂邩`FbN܂B
     * 
     * @param destPatients r
     * @throws Exception O
     */
    protected void checkSameName(VRList destPatients) throws Exception {
        IkenshoFirebirdDBManager dbm = new IkenshoFirebirdDBManager();
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT");
        sb.append(" PATIENT_NM");
        sb.append(",BIRTHDAY");
        sb.append(" FROM");
        sb.append(" PATIENT");
        VRArrayList nowPatients = (VRArrayList) dbm.executeQuery(sb.toString());
        dbm.finalize();

        int destEnd = destPatients.size();
        int nowEnd = nowPatients.size();
        for (int i = 0; i < nowEnd; i++) {
            VRMap nowRow = (VRMap) nowPatients.getData(i);
            String nowName = String.valueOf(VRBindPathParser.get("PATIENT_NM",
                    nowRow));
            String nowBirth = "";
            Object nowObj = VRBindPathParser.get("BIRTHDAY", nowRow);
            if (nowObj instanceof Date) {
                nowBirth = VRDateParser.format((Date) nowObj, "yyyyMMdd");
            }
            for (int j = 0; j < destEnd; j++) {
                VRMap destRow = (VRMap) destPatients.getData(j);
                String destName = String.valueOf(VRBindPathParser.get(
                        "PATIENT_NM", destRow));
                if (nowName.equals(destName)) {
                    String destBirth = "";
                    Object destObj = VRBindPathParser.get("BIRTHDAY", destRow);
                    if (destObj instanceof Date) {
                        destBirth = VRDateParser.format((Date) destObj,
                                "yyyyMMdd");
                    }
                    if (nowBirth.equals(destBirth)) {
                        VRBindPathParser.set("BATTING_FLAG", destRow, "");
                        VRBindPathParser.set("IMPORT_FLAG", destRow,
                                new Boolean(false));
                    }
                }
            }
        }
    }

    protected VRList innerFind(String where)throws Exception{
        IkenshoFirebirdDBManager dbm = new IkenshoFirebirdDBManager();

        StringBuffer sb = new StringBuffer();
        sb.append("SELECT");
        sb.append(" SYM_ACCESS_SPACE.SERIAL_ID");
        sb.append(",SYM_ACCESS_SPACE.PTID");
        sb.append(",SYM_ACCESS_SPACE.NAME");
        sb.append(",SYM_ACCESS_SPACE.KANANAME");
        sb.append(",SYM_ACCESS_SPACE.SEX");
        sb.append(",SYM_ACCESS_SPACE.BIRTHDAY");
        sb.append(",SYM_ACCESS_SPACE.HOME_POST");
        sb.append(",SYM_ACCESS_SPACE.HOME_ADRS");
        sb.append(",SYM_ACCESS_SPACE.HOME_BANTI");
        sb.append(",SYM_ACCESS_SPACE.HOME_TEL1");
        sb.append(" FROM");
        sb.append(" SYM_ACCESS_SPACE");
        sb.append(where);
        VRList result = dbm.executeQuery(sb.toString());
        // Z`ӌ`֕ϊ
        toIkenshoData(result);

        // `FbN
        checkSameName(result);

        patients.clearSelection();
        patientsData = result;
        patientsModelAdapter.setAdaptee(result);
        return result;
    }

    /**
     * ŏ̈ꗗy[W\܂B
     * @throws Exception O
     */
    protected void viewFirstPage() throws Exception{
        pageBegin = 1;
        readFromAccessSpace(1,PAGE_COUNT);
    }
    
    /**
     * ꎞ̈悩犳҂擾܂B
     * @param begin Jnԍ
     * @param count 
     * @throws Exception O
     */
    protected void readFromAccessSpace(int begin, int count)throws Exception{
        StringBuffer sb = new StringBuffer();
        sb.append(" WHERE");
        sb.append(" (SYM_ACCESS_SPACE.SERIAL_ID>=");
        sb.append(begin);
        sb.append(")AND(SYM_ACCESS_SPACE.SERIAL_ID<");
        sb.append(begin+count);
        sb.append(")");
        VRList result = innerFind(sb.toString());

        viewIndexBegin.setText(String.valueOf( begin));
        viewIndexEnd.setText(String.valueOf(begin+Math.min(count, result.size())-1));
        nextPage.setEnabled(begin+count<foundCount);
        previewPage.setEnabled(begin-count>0);
    }

    /**
     * Zvg\tg󂵂f[^ӌ`ɖ|󂵂܂B
     * 
     * @param src 
     * @throws ParseException O
     */
    protected void toIkenshoData(VRList src) throws Exception {
        int size = src.size();
        if (size <= 0) {
            return;
        }
        VRMap checkRow = (VRMap) src.getData(0);
        if (VRBindPathParser.has("PTID", checkRow)) {
            // ID
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                String val = getNotNullString("PTID", row);
                if (val.length() > 20) {
                    //20
                    val = val.substring(0, 20);
                }
                VRBindPathParser.set("CHART_NO", row, val);
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("CHART_NO", row, "");
            }
        }
        if (VRBindPathParser.has("NAME", checkRow)) {
            // 
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                String val = getNotNullString("NAME", row);
                if (val.length() > 15) {
                    val = val.substring(0, 15);
                }
                VRBindPathParser.set("PATIENT_NM", row, val);
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("PATIENT_NM", row, "");
            }
        }
        if (VRBindPathParser.has("KANANAME", checkRow)) {
            // Ȏ
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                String val = getNotNullString("KANANAME", row);
                if (val.length() > 30) {
                    val = val.substring(0, 30);
                }
                VRBindPathParser.set("PATIENT_KN", row, val);
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("PATIENT_KN", row, "");
            }
        }
        if (VRBindPathParser.has("SEX", checkRow)) {
            // 
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("SEX", row, Integer
                        .valueOf(getNotNullString("SEX", row)));
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("SEX", row, new Integer(0));
            }
        }
        if (VRBindPathParser.has("BIRTHDAY", checkRow)) {
            // N
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                Object obj = VRBindPathParser.get("BIRTHDAY", row);
                Calendar target;
                if (obj instanceof Date) {
                    target = Calendar.getInstance();
                    target.setTime((Date) obj);
                } else {
                    try {
                        target = Calendar.getInstance();
                        target.setTime(VRDateParser.parse(String.valueOf(obj)));
                    } catch (Exception ex) {
                        VRBindPathParser.set("AGE", row, new Integer(0));
                        VRBindPathParser.set("BIRTHDAY", row, null);
                        continue;
                    }
                }

                Calendar now = Calendar.getInstance();
                now.setLenient(true);
                now.add(Calendar.YEAR, 10);
                now.add(Calendar.DAY_OF_YEAR,
                        -target.get(Calendar.DAY_OF_YEAR) + 1);
                now.add(Calendar.YEAR, -target.get(Calendar.YEAR));

                VRBindPathParser.set("BIRTHDAY", row, target.getTime());
                VRBindPathParser.set("AGE", row, new Integer(now
                        .get(Calendar.YEAR) - 10));
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("AGE", row, "");
            }
        }

        if (VRBindPathParser.has("HOME_POST", checkRow)) {
            // X֔ԍ
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                String val = getNotNullString("HOME_POST", row);
                if (val.length() < 7) {
                    if (val.length() >= 3) {
                        val = val.substring(0, 3) + "-" + val.substring(3);
                    }
                } else {
                    val = val.substring(0, 3) + "-" + val.substring(3, 7);
                }
                VRBindPathParser.set("POST_CD", row, val);
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("POST_CD", row, "");
            }
        }

        if (VRBindPathParser.has("HOME_ADRS", checkRow)) {
            // Z
            if (VRBindPathParser.has("HOME_BANTI", checkRow)) {
                for (int i = 0; i < size; i++) {
                    VRMap row = (VRMap) src.getData(i);
                    String val = getNotNullString("HOME_ADRS", row)
                            + getNotNullString("HOME_BANTI", row);
                    if (val.length() > 50) {
                        val = val.substring(0, 50);
                    }
                    VRBindPathParser.set("ADDRESS", row, val);
                }
            } else {
                for (int i = 0; i < size; i++) {
                    VRMap row = (VRMap) src.getData(i);
                    String val = getNotNullString("HOME_ADRS", row);
                    if (val.length() > 50) {
                        val = val.substring(0, 50);
                    }
                    VRBindPathParser.set("ADDRESS", row, val);
                }
            }
        } else if (VRBindPathParser.has("HOME_BANTI", checkRow)) {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                String val = getNotNullString("HOME_BANTI", row);
                if (val.length() > 50) {
                    val = val.substring(0, 50);
                }
                VRBindPathParser.set("ADDRESS", row, val);
            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("ADDRESS", row, "");
            }
        }

        if (VRBindPathParser.has("HOME_TEL1", checkRow)) {
            // dbԍ
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                String val = getNotNullString("HOME_TEL1", row);
                val = toNotTelCharReplace(val);
                String[] tels = val.split("-");
                if (tels.length == 0) {
                    VRBindPathParser.set("TEL1", row, "");
                    VRBindPathParser.set("TEL2", row, "");
                    VRBindPathParser.set("TEL", row, "");
                    continue;
                }
                if (tels[0].length() > 5) {
                    String[] telSrc;
                    if (tels.length < 2) {
                        telSrc = new String[2];
                    } else {
                        telSrc = tels;
                    }
                    telSrc[0] = tels[0].substring(0, 5);
                    if (tels[0].length() > 9) {
                        telSrc[1] = tels[0].substring(5, 9) + "-"
                                + tels[0].substring(9, tels[0].length());
                    } else {
                        telSrc[1] = tels[0].substring(5, tels[0].length())
                                + "-";
                    }
                    tels = telSrc;
                }

                StringBuffer telSB = new StringBuffer();
                if (!"".equals(tels[0])) {
                    telSB.append(tels[0]);
                    telSB.append("-");
                }

                VRBindPathParser.set("TEL1", row, tels[0]);
                switch (tels.length) {
                case 0:
                case 1:
                    VRBindPathParser.set("TEL2", row, "");
                    break;
                case 2:
                    VRBindPathParser.set("TEL2", row, tels[1]);
                    if (!"".equals(tels[1])) {
                        if (tels[1].length() > 5) {
                            telSB.append(tels[1].substring(0, 5));
                            telSB.append("-");

                            if (tels[1].length() > 9) {
                                telSB.append(tels[1].substring(5, 9));
                            } else {
                                telSB.append(tels[1].substring(5));
                            }
                        } else {
                            telSB.append(tels[1]);
                        }
                    }
                    break;
                case 3:
                    VRBindPathParser.set("TEL2", row, tels[1] + "-" + tels[2]);
                    if (!"".equals(tels[1])) {
                        telSB.append(tels[1]);
                    }
                    telSB.append("-");
                    if (!"".equals(tels[2])) {
                        telSB.append(tels[2]);
                    }
                    break;
                default:
                    VRBindPathParser.set("TEL2", row, tels[1] + "-" + tels[2]);
                    if (!"".equals(tels[1])) {
                        telSB.append(tels[1]);
                    }
                    telSB.append("-");
                    if (!"".equals(tels[2])) {
                        telSB.append(tels[2]);
                    }
                    break;
                }

                VRBindPathParser.set("TEL", row, telSB.toString());

            }
        } else {
            for (int i = 0; i < size; i++) {
                VRMap row = (VRMap) src.getData(i);
                VRBindPathParser.set("TEL1", row, "");
                VRBindPathParser.set("TEL2", row, "");
                VRBindPathParser.set("TEL", row, "");
            }
        }
        for (int i = 0; i < size; i++) {
            VRMap row = (VRMap) src.getData(i);
            VRBindPathParser.set("IMPORT_FLAG", row, new Boolean(true));
            VRBindPathParser.set("BATTING_FLAG", row, "");
        }

    }
    
    protected void findActionPerformed(ActionEvent e) throws Exception {
        ACSplashable splash=null;

        try {
            // ʐMݒ̕ۑ
            String port = this.port.getText();
            String ip = hostName.getText();
            String user = userName.getText();
            String pass = password.getText();
            
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/IP", ip);
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/Port", port);
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/UserName", user);
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/Password", pass);
            
            
            if (!ACFrame.getInstance().getPropertyXML().writeWithCheck()) {
				return;
			}
            
            SymfowareDBManager dbm;
            try {
            	
                dbm = new SymfowareDBManager(ip, port, user, pass);
            } catch (Exception ex) {
                ACMessageBox
                        .showExclamation("ڑ̐ݒ肪słBڑzXg|[gԍĂB");
                return;
            }

            
            int count = 0;
            try {
            	
                if (ACMessageBox.showOkCancel("ׂĂ̊҂܂B낵łH"
                        + ACConstants.LINE_SEPARATOR
                        + "1005bx܂B",
                        ACMessageBox.FOCUS_CANCEL) != ACMessageBox.RESULT_OK) {
                    return;
                }
                    
                //XvbV̏
                ACFrameEventProcesser processer = ACFrame.getInstance().getFrameEventProcesser();
                if(processer instanceof IkenshoFrameEventProcesser){
                    splash = new ACStopButtonSplash();
                    ((ACSplash)splash).setIconPathes(((IkenshoFrameEventProcesser)processer).getSplashFilePathes());
                    Dimension d=((IkenshoFrameEventProcesser)processer).getSplashWindowSize();
                    if(d!=null){
                        d= new Dimension((int)d.getWidth(), (int)d.getHeight()+20);
                    }
                    
                    ((ACSplash)splash).refreshSize(d);
                    if (!((ACSplash)splash).isVisible()) {
                        ((ACSplash)splash).showModaless("f[^ʐM");
                    }
                    
                }
                    
                count = dbm.copyTable(splash);
            
            } catch (java.sql.SQLException sqlEx) {
            	StringBuffer sb = new StringBuffer();
            	sb.append("ڑɎs܂B\n");
            	sb.append("ERROR MESSAGE : " + sqlEx.getMessage() + "\n");
            	sb.append("SQLSTATE     : " + sqlEx.getSQLState() + "\n");
            	sb.append("ERROR CODE    : " + sqlEx.getErrorCode());
            	ACMessageBox.showExclamation(sb.toString());
            	return;
            	
            } catch (Exception ex) {
            	StringBuffer sb = new StringBuffer();
            	sb.append("ڑɎs܂B\n");
            	sb.append(ex.getMessage());
                ACMessageBox.showExclamation(sb.toString());
                return;
            }

            if (count <= 0) {
                splash = closeSplash(splash);
                ACMessageBox.show("ҏ񂪑݂܂B");
                return;
            }

            setStatusText(count + "擾܂B");
            foundCount = count;
            foundCountValue.setText(String.valueOf(count));

            //ŏPAGE_COUNT\
            viewFirstPage();
            splash = closeSplash(splash);

            ACMessageBox.show("ҏ擾܂B");

            patinetImport.setEnabled(true);
        } finally {
            splash = closeSplash(splash);
        }
    }
    
    public boolean canClose() throws Exception {
        try{
            //ԃe[uj
        	SymfowareDBManager.clearAccessSpace(new IkenshoFirebirdDBManager());
            }catch(Exception ex){}
        return super.canClose();
    }
    
    /**
     * XvbV܂B
     * @param splash Ώۂ̃XvbV
     * @return đׂXvbV
     */
    protected ACSplashable closeSplash(ACSplashable splash) {
        if (splash != null) {
            splash.close();
        }
        return null;
    }


    /**
     * ȊOԂ܂B
     * 
     * @param src ϊ
     * @return ϊ
     */
    protected String toNotTelCharReplace(String src) {
        StringBuffer sb = new StringBuffer();
        int end = src.length();
        for (int i = 0; i < end; i++) {
            char c = src.charAt(i);
            if ((c == '-') || ((c >= '0') && (c <= '9'))) {
                sb.append(c);
            }
        }
        return sb.toString();
    }

    /**
     * woChpX̒l𕶎ƂĕԂ܂BNullȂ΋󕶎Ԃ܂B
     * 
     * @param path oChpX
     * @param row o
     * @throws ParseException O
     * @return ϊ
     */
    protected String getNotNullString(String path, VRMap row)
            throws ParseException {
        Object obj = VRBindPathParser.get(path, row);
        if (obj == null) {
            return "";
        }
        return String.valueOf(obj);
    }

    protected void insertActionPerformed(ActionEvent e) throws Exception {
        // `FbN{bNX̕ҏWԂ̊m
        patients.stopCellEditing("IMPORT_FLAG");

        if (doInsert()) {
            if(patientsData!=null){
                checkSameName(patientsData);
                patients.invalidate();
                patients.repaint();
            }

            ACMessageBox.show("ҏ荞݂܂B"); 
        }
    }

    /**
     * ǉs܂B
     * 
     * @throws Exception O
     * @return boolean ǉɐ
     */
    private boolean doInsert() throws Exception {

        IkenshoFirebirdDBManager dbm = null;
        try {
            dbm = new IkenshoFirebirdDBManager();
            dbm.beginTransaction();

            VRArrayList importPatients = getImportCheckedRows();
            int end = importPatients.getDataSize();
            for (int i = 0; i < end; i++) {
                VRMap row = (VRMap) importPatients.getData(i);

                StringBuffer sb = new StringBuffer();
                sb.append("INSERT INTO");
                sb.append(" PATIENT");
                sb.append(" (");
                sb.append(" PATIENT_NM");
                sb.append(",PATIENT_KN");
                sb.append(",SEX");
                sb.append(",BIRTHDAY");
                sb.append(",AGE");
                sb.append(",POST_CD");
                sb.append(",ADDRESS");
                sb.append(",TEL1");
                sb.append(",TEL2");
                sb.append(",KOUSIN_DT");
                sb.append(",LAST_TIME");
                sb.append(" )");
                sb.append(" VALUES");
                sb.append(" (");
                sb.append(getDBSafeString("PATIENT_NM", row));
                sb.append(",");
                String kana= getDBSafeString("PATIENT_KN", row);
                sb.append(kana);
                sb.append(",");
                sb.append(getDBSafeNumber("SEX", row));
                sb.append(",");
                sb.append(getDBSafeDate("BIRTHDAY", row));
                sb.append(",");
                sb.append(getDBSafeString("AGE", row));
                sb.append(",");
                sb.append(getDBSafeString("POST_CD", row));
                sb.append(",");
                sb.append(getDBSafeString("ADDRESS", row));
                sb.append(",");
                sb.append(getDBSafeString("TEL1", row));
                sb.append(",");
                sb.append(getDBSafeString("TEL2", row));
                sb.append(",CURRENT_TIMESTAMP");
                sb.append(",CURRENT_TIMESTAMP");
                sb.append(")");

                dbm.executeUpdate(sb.toString());

            }

            dbm.commitTransaction();
            dbm.finalize();

        } catch (Exception ex) {
            if (dbm != null) {
                dbm.rollbackTransaction();
                dbm.finalize();
            }
            throw ex;
        }

        return true;
    }

    /**
     * 荞݃`FbN̂sf[^WԂ܂B
     * 
     * @throws ParseException ͗O
     * @return ArrayList sf[^W
     */
    private VRArrayList getImportCheckedRows() throws ParseException {
        VRArrayList rows = new VRArrayList();

        int end = patientsData.getDataSize();
        for (int i = 0; i < end; i++) {
            VRMap row = (VRMap) patientsData.getData(i);
            Object obj = row.getData("IMPORT_FLAG");
            if (obj instanceof Boolean) {
                Boolean val = (Boolean) obj;
                if (val.booleanValue()) {
                    rows.add(row);
                }
            }
        }
        return rows;
    }

    /**
     * R|[lg܂B
     * 
     * @throws Exception O
     */
    private void jbInit() throws Exception {
        accessSettings.setLayout(new VRLayout());
        hostNames.setText("ڑzXg");
        hostName.setColumns(15);
        hostName.setMaxLength(255);
        hostName.setText("127.0.0.1");
        userName.setMaxLength(255);
        userName.setText("ormaster");
        userName.setColumns(15);
        userNames.setText("[U[");
        port.setMaxLength(5);
        port.setText("8013");
        port.setColumns(5);
        ports.setText("|[gԍ");
        port.setCharType(VRCharType.ONLY_NUMBER);
        password.setColumns(15);
        password.setMaxLength(255);
        password.setText("ormaster");
        passwords.setText("pX[h");

        accessSettings.setText("ڑݒ");
        buttons.setText("Symfowaref[^荞");
        receiptAccess.setIconPath(ACConstants.ICON_PATH_OPEN_24);
        receiptAccess.setMnemonic('A');
        receiptAccess.setText("ʐM(A)");
        receiptAccess.setToolTipText("Mҏ荞݂܂B");
        
        patinetImport.setIconPath(ACConstants.ICON_PATH_UPDATE_24);
        patinetImport.setEnabled(false);
        patinetImport.setMnemonic('I');
        patinetImport.setText("荞(I)");
        patinetImport.setToolTipText("SymfowareƒʐMsȂ܂B");
        accessSettings.add(hostNames, VRLayout.FLOW_INSETLINE);
        accessSettings.add(ports, VRLayout.FLOW_INSETLINE);
        accessSettings.add(userNames, VRLayout.FLOW_INSETLINE);
        accessSettings.add(passwords, VRLayout.FLOW_INSETLINE_RETURN);
        passwords.add(password, null);
        hostNames.add(hostName, null);
        ports.add(port, null);
        userNames.add(userName, null);
        this.add(buttons, VRLayout.NORTH);
        buttons.add(patinetImport, VRLayout.EAST);
        buttons.add(receiptAccess, VRLayout.EAST);
        this.add(accessSettings, VRLayout.NORTH);
        this.add(patients, VRLayout.CLIENT);

        
        ((VRLayout)accessSettings.getLayout()).setAutoWrap(false);
        this.add(filterSettings, VRLayout.NORTH);
        filterSettings.setHgap(0);
        filterSettings.add(checkEditMethodContainer, VRLayout.FLOW);
        filterSettings.add(previewPage, VRLayout.FLOW);
        filterSettings.add(nextPage, VRLayout.FLOW);
        filterSettings.add(foundCountValue, VRLayout.FLOW);
        filterSettings.add(foundCountUnit, VRLayout.FLOW);
        filterSettings.add(viewIndexBegin, VRLayout.FLOW);
        filterSettings.add(viewIndexBeginUnit, VRLayout.FLOW);
        filterSettings.add(viewIndexEnd, VRLayout.FLOW);
        filterSettings.add(viewIndexEndUnit, VRLayout.FLOW);
        checkEditMethodContainer.setText("`FbN");
        checkEditMethod.setEditable(false);
        checkEditMethod.setModel(new String[]{"ׂđI","ׂďO","I𔽓]","dO"});
        checkEditMethod.setSelectedIndex(0);
        checkEditMethod.setColumns(6);
        checkEdit.setText("s");
        checkEditMethodContainer.add(checkEditMethod, VRLayout.FLOW);
        checkEditMethodContainer.add(checkEdit, VRLayout.FLOW);
        nextPage.setText("");
        nextPage.setToolTipText("" + PAGE_COUNT + "\܂B");
        nextPage.setEnabled(false);
        previewPage.setText("O");
        previewPage.setToolTipText("O"+PAGE_COUNT+"\܂B");
        previewPage.setEnabled(false);
        
        patientID.setColumns(10);
        patientID.setMaxLength(10);
        patientID.setIMEMode(InputSubset.KANJI);
        patientID.setEnabled(false);
        filterSettings.setText("荞ݐݒ");
        foundCountValue.setText("0");
        foundCountValue.setFormat(NumberFormat.getNumberInstance());
        foundCountUnit.setText("  ");
        viewIndexBegin.setText("0");
        viewIndexBegin.setFormat(NumberFormat.getNumberInstance());
        viewIndexBeginUnit.setText(" - ");
        viewIndexEnd.setText("0");
        viewIndexEnd.setFormat(NumberFormat.getNumberInstance());
        viewIndexEndUnit.setText(" ");

        previewPage.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                try{
                    pageBegin-=PAGE_COUNT;
                    readFromAccessSpace(pageBegin, PAGE_COUNT);
                }catch(Exception ex){
                    IkenshoCommon.showExceptionMessage(ex);
                }
            }
        });
        nextPage.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                try{
                    pageBegin+=PAGE_COUNT;
                    readFromAccessSpace(pageBegin, PAGE_COUNT);
                }catch(Exception ex){
                    IkenshoCommon.showExceptionMessage(ex);
                }
            }
        });
        checkEdit.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e) {
                if(patientsData==null){
                    return;
                }
                // `FbN{bNX̕ҏWԂ̊m
                patients.stopCellEditing("IMPORT_FLAG");
                
                Iterator it = patientsData.iterator();
                switch(checkEditMethod.getSelectedIndex()){
                case 0://ׂđI
                    while(it.hasNext()){
                        ((Map)it.next()).put("IMPORT_FLAG", Boolean.TRUE);
                    }
                    break;
                case 1://ׂďO
                    while(it.hasNext()){
                        ((Map)it.next()).put("IMPORT_FLAG", Boolean.FALSE);
                    }
                    break;
                case 2://I𔽓]
                    while(it.hasNext()){
                        Map row =(Map)it.next(); 
                        Boolean val; 
                        if(Boolean.TRUE.equals(row.get("IMPORT_FLAG"))){
                            val = Boolean.FALSE; 
                        }else{
                            val = Boolean.TRUE;
                        }
                        row.put("IMPORT_FLAG", val);
                    }
                    break;
                case 3://dO
                    while(it.hasNext()){
                        Map row =(Map)it.next(); 
                        if("".equals(row.get("BATTING_FLAG"))){
                            row.put("IMPORT_FLAG", Boolean.FALSE);
                        }
                    }
                    break;
                }
                patients.invalidate();
                patients.repaint();
            }
        });
        
    }

    public boolean canBack(VRMap parameters) {
        try{
            //ԃe[uj
        	SymfowareDBManager.clearAccessSpace(new IkenshoFirebirdDBManager());
        }catch(Exception ex){}
        return true;
    }

    public ACAffairButtonBar getButtonBar() {
        return buttons;
    }

    public Component getFirstFocusComponent() {
        return hostName;
    }


}
