package com.fc2.blog68.symfoware.ikensyo;

import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.util.*;

import javax.swing.SwingConstants;

import com.fc2.blog68.symfoware.lib.SymfowareDBManager;

import jp.nichicom.ac.*;
import jp.nichicom.ac.component.*;
import jp.nichicom.ac.component.table.*;
import jp.nichicom.ac.container.*;
import jp.nichicom.ac.core.*;
import jp.nichicom.ac.pdf.ACChotarouXMLUtilities;
import jp.nichicom.ac.pdf.ACChotarouXMLWriter;
import jp.nichicom.ac.util.*;
import jp.nichicom.ac.util.adapter.*;
import jp.nichicom.ac.util.splash.*;
import jp.nichicom.vr.bind.*;
import jp.nichicom.vr.component.table.VRTableColumnModel;
import jp.nichicom.vr.layout.VRLayout;
import jp.nichicom.vr.text.VRCharType;
import jp.nichicom.vr.text.parsers.VRDateParser;
import jp.nichicom.vr.util.*;
import jp.or.med.orca.ikensho.IkenshoConstants;
import jp.or.med.orca.ikensho.affair.IkenshoAffairContainer;
import jp.or.med.orca.ikensho.affair.IkenshoFrameEventProcesser;
import jp.or.med.orca.ikensho.lib.IkenshoCommon;
import jp.or.med.orca.ikensho.sql.IkenshoFirebirdDBManager;


public class SymfowareListPrint extends IkenshoAffairContainer implements ACAffairable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private ACAffairButtonBar buttons = new ACAffairButtonBar();
    private ACTable patients = new ACTable();
    private ACGroupBox accessSettings = new ACGroupBox();
    private ACLabelContainer hostNames = new ACLabelContainer();
    private ACTextField hostName = new ACTextField();
    private ACTextField userName = new ACTextField();
    private ACLabelContainer userNames = new ACLabelContainer();
    private ACTextField port = new ACTextField();
    private ACLabelContainer ports = new ACLabelContainer();
    private ACTextField password = new ACTextField();
    private ACLabelContainer passwords = new ACLabelContainer();
    private ACAffairButton receiptAccess = new ACAffairButton();
    private VRArrayList importPatients = new VRArrayList();
    private ACTableModelAdapter patientsModelAdapter;
    private ACAffairButton patinetList = new ACAffairButton();
    private VRList patientsData;
    private ACLabel foundCountValue = new ACLabel();

    public void initAffair(ACAffairInfo affair) {
        setStatusText("ꗗ");
        
        String ip = "127.0.0.1";
        String port = "2002";
        String user = "Administrator";
        String pass = "";
        
        try{
            //ߋ̒ʐMݒǂݍ
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/IP")){
                ip = ACFrame.getInstance().getProperty("SymfowareAccess/IP");
            }
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/Port")){
                port = ACFrame.getInstance().getProperty("SymfowareAccess/Port");
            }
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/UserName")){
                user = ACFrame.getInstance().getProperty("SymfowareAccess/UserName");
            }
            if(ACFrame.getInstance().hasProperty("SymfowareAccess/Password")){
                pass = ACFrame.getInstance().getProperty("SymfowareAccess/Password");
            }
        }catch(Exception ex){
            
        }
        hostName.setText(ip);
        userName.setText(user);
        password.setText(pass);
        this.port.setText(port);
    }

    /**
     * RXgN^
     */
    public SymfowareListPrint() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }

        addFindTrigger(receiptAccess);
        addPrintTrigger(patinetList);


        patients.setColumnModel(new VRTableColumnModel(new ACTableColumn[] {
                new ACTableColumn(1, 100, ""),
                new ACTableColumn(2, 120, "ӂ肪"),
                new ACTableColumn(3, 32, "", SwingConstants.CENTER,
                        IkenshoConstants.FORMAT_SEX),
                new ACTableColumn(4, 32, "N", SwingConstants.RIGHT,
                        IkenshoConstants.FORMAT_NOW_AGE),
                new ACTableColumn(4, 110, "N",
                        IkenshoConstants.FORMAT_ERA_YMD),
                new ACTableColumn(5, 63, "X֔ԍ"),
                new ACTableColumn(6, 280, "Z"),
                new ACTableColumn(7, 280, "Ԓn"),
                new ACTableColumn(8, 120, "AiTELj"), }));

        patientsModelAdapter = new ACTableModelAdapter(importPatients,
                new String[] { "PTID", "NAME", "KANANAME", "SEX", "BIRTHDAY",
                        "POST_CD", "HOME_ADRS", "HOME_BANTI" , "HOME_TEL1"});

        patients.setModel(patientsModelAdapter);

    }

    protected VRList innerFind()throws Exception{
        IkenshoFirebirdDBManager dbm = new IkenshoFirebirdDBManager();

        StringBuffer sb = new StringBuffer();
        sb.append("SELECT");
        sb.append(" SYM_ACCESS_SPACE.SERIAL_ID");
        sb.append(",SYM_ACCESS_SPACE.PTID");
        sb.append(",SYM_ACCESS_SPACE.NAME");
        sb.append(",SYM_ACCESS_SPACE.KANANAME");
        sb.append(",SYM_ACCESS_SPACE.SEX");
        sb.append(",SYM_ACCESS_SPACE.BIRTHDAY");
        sb.append(",SYM_ACCESS_SPACE.HOME_POST");
        sb.append(",SYM_ACCESS_SPACE.HOME_ADRS");
        sb.append(",SYM_ACCESS_SPACE.HOME_BANTI");
        sb.append(",SYM_ACCESS_SPACE.HOME_TEL1");
        sb.append(" FROM");
        sb.append(" SYM_ACCESS_SPACE");
        
        VRList result = dbm.executeQuery(sb.toString());
        // ӌ`֕ϊ
        toIkenshoData(result);

        patients.clearSelection();
        patientsData = result;
        patientsModelAdapter.setAdaptee(result);
        return result;
    }

    /**
     * SymfowareMf[^ӌ`ɖ|󂵂܂B
     * 
     * @param src 
     * @throws ParseException O
     */
    protected void toIkenshoData(VRList src) throws Exception {
    	
        for (int i = 0; i < src.size(); i++) {
            VRMap row = (VRMap) src.getData(i);
            
            //
            VRBindPathParser.set("SEX", row, Integer.valueOf(getNotNullString("SEX", row)));
            
            //X֔ԍ
            String val = getNotNullString("HOME_POST", row);
            if (val.length() < 7) {
                if (val.length() >= 3) {
                    val = val.substring(0, 3) + "-" + val.substring(3);
                }
            } else {
                val = val.substring(0, 3) + "-" + val.substring(3, 7);
            }
            VRBindPathParser.set("POST_CD", row, val);
            
            //N
            Object obj = VRBindPathParser.get("BIRTHDAY", row);
            Calendar target;
            if (obj instanceof Date) {
                target = Calendar.getInstance();
                target.setTime((Date) obj);
            } else {
                try {
                    target = Calendar.getInstance();
                    target.setTime(VRDateParser.parse(String.valueOf(obj)));
                } catch (Exception ex) {
                    VRBindPathParser.set("AGE", row, new Integer(0));
                    VRBindPathParser.set("BIRTHDAY", row, null);
                    continue;
                }
            }

            Calendar now = Calendar.getInstance();
            now.setLenient(true);
            now.add(Calendar.YEAR, 10);
            now.add(Calendar.DAY_OF_YEAR,
                    -target.get(Calendar.DAY_OF_YEAR) + 1);
            now.add(Calendar.YEAR, -target.get(Calendar.YEAR));

            VRBindPathParser.set("BIRTHDAY", row, target.getTime());
            VRBindPathParser.set("AGE", row, new Integer(now
                    .get(Calendar.YEAR) - 10));
        }
    }
    
    protected void findActionPerformed(ActionEvent e) throws Exception {
        ACSplashable splash=null;

        try {
            // ʐMݒ̕ۑ
            String port = this.port.getText();
            String ip = hostName.getText();
            String user = userName.getText();
            String pass = password.getText();
            
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/IP", ip);
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/Port", port);
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/UserName", user);
            ACFrame.getInstance().getPropertyXML().setForceValueAt(
                    "SymfowareAccess/Password", pass);
            
            
            if (!ACFrame.getInstance().getPropertyXML().writeWithCheck()) {
				return;
			}
            
            SymfowareDBManager dbm;
            try {
            	
                dbm = new SymfowareDBManager(ip, port, user, pass);
            } catch (Exception ex) {
                ACMessageBox
                        .showExclamation("ڑ̐ݒ肪słBڑzXg|[gԍĂB");
                return;
            }

            
            int count = 0;
            try {
            	
                if (ACMessageBox.showOkCancel("ׂĂ̊҂܂B낵łH"
                        + ACConstants.LINE_SEPARATOR
                        + "1005bx܂B",
                        ACMessageBox.FOCUS_CANCEL) != ACMessageBox.RESULT_OK) {
                    return;
                }
                    
                //XvbV̏
                ACFrameEventProcesser processer = ACFrame.getInstance().getFrameEventProcesser();
                if(processer instanceof IkenshoFrameEventProcesser){
                    splash = new ACStopButtonSplash();
                    ((ACSplash)splash).setIconPathes(((IkenshoFrameEventProcesser)processer).getSplashFilePathes());
                    Dimension d=((IkenshoFrameEventProcesser)processer).getSplashWindowSize();
                    if(d!=null){
                        d= new Dimension((int)d.getWidth(), (int)d.getHeight()+20);
                    }
                    
                    ((ACSplash)splash).refreshSize(d);
                    if (!((ACSplash)splash).isVisible()) {
                        ((ACSplash)splash).showModaless("f[^ʐM");
                    }
                    
                }
                    
                count = dbm.copyTable(splash);
            
            } catch (java.sql.SQLException sqlEx) {
            	StringBuffer sb = new StringBuffer();
            	sb.append("ڑɎs܂B\n");
            	sb.append("ERROR MESSAGE : " + sqlEx.getMessage() + "\n");
            	sb.append("SQLSTATE     : " + sqlEx.getSQLState() + "\n");
            	sb.append("ERROR CODE    : " + sqlEx.getErrorCode());
            	ACMessageBox.showExclamation(sb.toString());
            	return;
            	
            } catch (Exception ex) {
            	StringBuffer sb = new StringBuffer();
            	sb.append("ڑɎs܂B\n");
            	sb.append(ex.getMessage());
                ACMessageBox.showExclamation(sb.toString());
                return;
            }

            if (count <= 0) {
                splash = closeSplash(splash);
                ACMessageBox.show("ҏ񂪑݂܂B");
                return;
            }

            setStatusText(count + "擾܂B");
            foundCountValue.setText(String.valueOf(count));

            //\s
            innerFind();
            splash = closeSplash(splash);

            ACMessageBox.show("ҏ擾܂B");

            patinetList.setEnabled(true);
        } finally {
            splash = closeSplash(splash);
        }
    }
    
    public boolean canClose() throws Exception {
        try{
            //ԃe[uj
        	SymfowareDBManager.clearAccessSpace(new IkenshoFirebirdDBManager());
            }catch(Exception ex){}
        return super.canClose();
    }
    
    /**
     * XvbV܂B
     * @param splash Ώۂ̃XvbV
     * @return đׂXvbV
     */
    protected ACSplashable closeSplash(ACSplashable splash) {
        if (splash != null) {
            splash.close();
        }
        return null;
    }


    /**
     * ȊOԂ܂B
     * 
     * @param src ϊ
     * @return ϊ
     */
    protected String toNotTelCharReplace(String src) {
        StringBuffer sb = new StringBuffer();
        int end = src.length();
        for (int i = 0; i < end; i++) {
            char c = src.charAt(i);
            if ((c == '-') || ((c >= '0') && (c <= '9'))) {
                sb.append(c);
            }
        }
        return sb.toString();
    }

    /**
     * woChpX̒l𕶎ƂĕԂ܂BNullȂ΋󕶎Ԃ܂B
     * 
     * @param path oChpX
     * @param row o
     * @throws ParseException O
     * @return ϊ
     */
    protected String getNotNullString(String path, VRMap row)
            throws ParseException {
        Object obj = VRBindPathParser.get(path, row);
        if (obj == null) {
            return "";
        }
        return String.valueOf(obj);
    }

    /**
     * s
     */
    protected void printActionPerformed(ActionEvent e) throws Exception {
        
    	if (patientsData.size() == 0) {
    		return;
    	}
    	
        if (ACMessageBox.showOkCancel("ꗗ̈", "ꗗ\o͂Ă낵łH" ,
                "(O)",
                'O') != ACMessageBox.RESULT_OK) {
            return;
        }
    	
    	//pIuWFNg
        ACChotarouXMLWriter pd = new ACChotarouXMLWriter();
        
        pd.beginPrintEdit();
        //sym_listƂOŁASymfoList.xml`̂ǉ
        ACChotarouXMLUtilities.addFormat(pd, "sym_list", "SymfoList.xml");
        
        for (int i = 0; i < patientsData.size(); i++) {
            VRMap row = (VRMap) patientsData.getData(i);
            int index = (i % 20) + 1;
            if (index == 1) {
            	if (i != 0){
            		pd.endPageEdit();
            	}
            	pd.beginPageEdit("sym_list");
            }
            //
            IkenshoCommon.addString(pd, row, "NAME", "table.h"+ index + ".name");
            //Ȏ
            IkenshoCommon.addString(pd, row, "KANANAME", "table.h"+ index + ".name_kana");
            //
            IkenshoCommon.addString(pd, row, "SEX", "table.h"+ index + ".sex");
            Object sex = row.get("SEX");
            if (sex instanceof Integer) {
                switch (((Integer) sex).intValue()) {
                case 1:
                    IkenshoCommon.addString(pd, "table.h" + index + ".sex","j");
                    break;
                case 2:
                    IkenshoCommon.addString(pd, "table.h" + index + ".sex","");
                    break;
                }
            }
            //N
            IkenshoCommon.addString(pd, "table.h"+ index + ".age", IkenshoConstants.FORMAT_NOW_AGE.format(row.get("BIRTHDAY")));
            //N
            IkenshoCommon.addString(pd, "table.h"+ index + ".birdhday", IkenshoConstants.FORMAT_ERA_YMD.format(row.get("BIRTHDAY")));
            
            //X֔ԍ
            IkenshoCommon.addString(pd, row, "POST_CD", "table.h"+ index + ".zipcode");
            //Z
            IkenshoCommon.addString(pd, row, "HOME_ADRS", "table.h"+ index + ".address");
            //Ԓn
            IkenshoCommon.addString(pd, row, "HOME_BANTI", "table.h"+ index + ".sub_address");
            //A(TEL)
            IkenshoCommon.addString(pd, row, "HOME_TEL1", "table.h"+ index + ".tel");
            
        }
        pd.endPageEdit();
        pd.endPrintEdit();
        openPDF(pd);
    }

 

    /**
     * R|[lg܂B
     * 
     * @throws Exception O
     */
    private void jbInit() throws Exception {
        accessSettings.setLayout(new VRLayout());
        hostNames.setText("ڑzXg");
        hostName.setColumns(15);
        hostName.setMaxLength(255);
        hostName.setText("127.0.0.1");
        userName.setMaxLength(255);
        userName.setText("ormaster");
        userName.setColumns(15);
        userNames.setText("[U[");
        port.setMaxLength(5);
        port.setText("8013");
        port.setColumns(5);
        ports.setText("|[gԍ");
        port.setCharType(VRCharType.ONLY_NUMBER);
        password.setColumns(15);
        password.setMaxLength(255);
        password.setText("ormaster");
        passwords.setText("pX[h");

        accessSettings.setText("ڑݒ");
        buttons.setText("ꗗ");
        receiptAccess.setIconPath(ACConstants.ICON_PATH_OPEN_24);
        receiptAccess.setMnemonic('A');
        receiptAccess.setText("ʐM(A)");
        receiptAccess.setToolTipText("Mҏ荞݂܂B");
        
        patinetList.setIconPath(IkenshoConstants.BUTTON_IMAGE_PATH_TABLE_PRINT);
        patinetList.setEnabled(false);
        patinetList.setMnemonic('P');
        patinetList.setText("ꗗ(P)");
        patinetList.setToolTipText("ꗗ̈s܂B");
        
        accessSettings.add(hostNames, VRLayout.FLOW_INSETLINE);
        accessSettings.add(ports, VRLayout.FLOW_INSETLINE);
        accessSettings.add(userNames, VRLayout.FLOW_INSETLINE);
        accessSettings.add(passwords, VRLayout.FLOW_INSETLINE_RETURN);
        passwords.add(password, null);
        hostNames.add(hostName, null);
        ports.add(port, null);
        userNames.add(userName, null);
        this.add(buttons, VRLayout.NORTH);
        buttons.add(patinetList, VRLayout.EAST);
        buttons.add(receiptAccess, VRLayout.EAST);
        this.add(accessSettings, VRLayout.NORTH);
        this.add(patients, VRLayout.CLIENT);
        
    }

    public boolean canBack(VRMap parameters) {
        try{
            //ԃe[uj
        	SymfowareDBManager.clearAccessSpace(new IkenshoFirebirdDBManager());
        }catch(Exception ex){}
        return true;
    }

    public ACAffairButtonBar getButtonBar() {
        return buttons;
    }

    public Component getFirstFocusComponent() {
        return hostName;
    }

}
