package com.fc2.blog68.symfoware.lib;

import java.net.*;
import java.sql.*;

import jp.nichicom.ac.text.ACTextUtilities;
import jp.nichicom.ac.util.splash.*;
import jp.or.med.orca.ikensho.sql.IkenshoFirebirdDBManager;

public class SymfowareDBManager {
	
	private Connection con = null;
	private String host = null;
	private String port = null;
	private String uid = null;
	private String pwd = null;
	
	public SymfowareDBManager(String host, String port, String uid, String pwd) {
		this.host = host;
		this.port = port;
		this.uid = uid;
		this.pwd = pwd;
	}
	
	public int copyTable(ACSplashable splash) throws Exception {
        
		
        IkenshoFirebirdDBManager dbm = null;
        dbm = new IkenshoFirebirdDBManager();
        dbm.beginTransaction();
        // ڍs̈񂷂ׂď
        clearAccessSpace(dbm);
        
        //NCAgIPAhX擾
        String ip = getLocalIP();
        int count = 1;
		
        try {
			//RlNVI[v
			open();
			
			Statement stmt = con.createStatement();
			ResultSet rs = stmt.executeQuery("SELECT * FROM SC_SAMPLE.PATIENT");
			
			
			
			while (rs.next()){
				
				count = doCopy(dbm, rs, ip, count);
				
	            if (splash instanceof ACSplash) {
	                // 󋵕\
	                String message = (count - 1) + " ";
	                String name = ACTextUtilities.trim(rs.getString(""));
	                if (name != null) {
	                    message += " / " + name;
	                }
	                ((ACSplash) splash).setMessage(message);
	                
	                if(splash instanceof ACStopButtonSplash){
	                    if(((ACStopButtonSplash)splash).isStopRequested()){
	                        //~vĎ
	                        break;
	                    }
	                }
	            }
			}
		
		
        } catch (Exception e){
        	dbm.rollbackTransaction();
        	throw e;
        } finally {
        	close();
        }
        dbm.commitTransaction();
        
        return count -1;
	}
	
	private int doCopy(IkenshoFirebirdDBManager dbm, ResultSet rs, String ip, int count) throws Exception {
		
        StringBuffer sb = new StringBuffer();
        sb.append("INSERT INTO");
        sb.append(" SYM_ACCESS_SPACE");
        sb.append(" (");
        sb.append(" LOCAL_IP");
        sb.append(",SERIAL_ID");
        sb.append(",PTID");
        sb.append(",NAME");
        sb.append(",KANANAME");
        sb.append(",SEX");
        sb.append(",BIRTHDAY");
        sb.append(",HOME_POST");
        sb.append(",HOME_ADRS");
        sb.append(",HOME_BANTI");
        sb.append(",HOME_TEL1");
        sb.append(",LAST_TIME");
        sb.append(" )");
        sb.append(" VALUES");
        sb.append(" (");
        sb.append("'" + ip + "'");
        sb.append(",");
        sb.append(count++);
        sb.append(",");
        sb.append("'" + rs.getShort("ԍ") + "'");
        sb.append(",'");
        sb.append(ACTextUtilities.trim(rs.getString("")));
        sb.append("','");
        sb.append(ACTextUtilities.trim(rs.getString("Ȏ")));
        sb.append("','");
        sb.append(rs.getString(""));
        sb.append("','");
        sb.append(rs.getString("N").replaceAll("-", ""));
        sb.append("','");
        sb.append(ACTextUtilities.trim(rs.getString("X֔ԍ")));
        sb.append("','");
        sb.append(ACTextUtilities.trim(rs.getString("Z")));
        sb.append("','");
        sb.append(ACTextUtilities.trim(rs.getString("Ԓn")));
        sb.append("','");
        sb.append(rs.getString("dbԍ"));
        sb.append("',");
        sb.append("CURRENT_TIMESTAMP");
        sb.append(")");
        
        dbm.executeUpdate(sb.toString());
        
        return count;
            
	}
	
    public static void clearAccessSpace(IkenshoFirebirdDBManager dbm) throws Exception{
        try{
            //[JIPɊY郌R[h
        	StringBuffer sb = new StringBuffer();
            sb.append("DELETE FROM");
            sb.append(" SYM_ACCESS_SPACE");
            sb.append(" WHERE");
            sb.append("(LOCAL_IP='");
            sb.append(getLocalIP());
            sb.append("')");
            dbm.executeUpdate(sb.toString());
        }catch(Exception ex){
            //݂Ȃ΍쐬
            StringBuffer sb = new StringBuffer();
            sb.append("CREATE TABLE");
            sb.append(" SYM_ACCESS_SPACE");
            sb.append(" (");
            sb.append(" LOCAL_IP VARCHAR(30) NOT NULL");
            sb.append(",SERIAL_ID INTEGER NOT NULL");
            sb.append(",PTID VARCHAR(10)");
            sb.append(",NAME VARCHAR(100)");
            sb.append(",KANANAME VARCHAR(100)");
            sb.append(",SEX CHAR(1)");
            sb.append(",BIRTHDAY CHAR(8)");
            sb.append(",HOME_POST VARCHAR(7)");
            sb.append(",HOME_ADRS VARCHAR(200)");
            sb.append(",HOME_BANTI VARCHAR(200)");
            sb.append(",HOME_TEL1 VARCHAR(15)");
            sb.append(",LAST_TIME TIMESTAMP");
            sb.append(",PRIMARY KEY (");
            sb.append(" LOCAL_IP");
            sb.append(",SERIAL_ID");
            sb.append(" )");
            sb.append(")");
            dbm.executeUpdate(sb.toString());
            dbm.commitTransaction();
            //R~bgȂCREATEfȂ
            dbm.beginTransaction();
        }
    }
	
    /**
     * [JzXgIPAhXԂ܂B
     * @return IPAhX
     * @throws UnknownHostException zXgO
     */
    protected static String getLocalIP() throws UnknownHostException{
        InetAddress local=InetAddress.getLocalHost();
        if(local!=null){
            String address =local.getHostAddress();
            if(address!=null){
                if(address.length()>30){
                    address = address.substring(0,30);
                }
                return address;
            }
        }
        return "localhost";
    }
	
	private void open() throws Exception  {
		
		 //Class.forName("com.fujitsu.symfoware.jdbc.SYMDriver");
		Class.forName("com.fujitsu.symfoware.jdbc.RDADriver");
         con =  DriverManager.getConnection("jdbc:symforda://" + host + ":" + port + "/SAMPLE", uid, pwd);
         
         con.setAutoCommit(false);
	}
	
	private void close() throws Exception {
		if (con != null){
			con.close();
		}
	}
	
}
